"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _reactNativeHighlightText = _interopRequireDefault(require("@sanar/react-native-highlight-text"));
var _react = _interopRequireWildcard(require("react"));
var _reactNativeGestureHandler = require("react-native-gesture-handler");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ScrollableHighlightedText(_ref, ref) {
  let {
    text = '',
    textToHighlight
  } = _ref;
  // const [textToHighlight, setTextToSearch] = useState();
  const flatList = (0, _react.useRef)();
  const [arrayOfLines, setArrayOfLines] = (0, _react.useState)([]);
  const arrayOfIndexes = (0, _react.useRef)([]);
  const counter = (0, _react.useRef)(-1);
  (0, _react.useImperativeHandle)(ref, () => ({
    // searchText(word) {
    //   setTextToSearch(word);
    // },
    scrollToNext() {
      if (arrayOfIndexes.current.length === 0) {
        return;
      }
      try {
        counter.current++;
        flatList.current?.scrollToIndex({
          index: arrayOfIndexes?.current?.[counter.current],
          animated: true
        });
      } catch (error) {
        counter.current = 0;
        flatList.current?.scrollToIndex({
          index: arrayOfIndexes?.current?.[counter.current],
          animated: true
        });
      }
    },
    scrollToPrevious() {
      if (arrayOfIndexes.current.length === 0) {
        return;
      }
      try {
        counter.current--;
        flatList.current?.scrollToIndex({
          index: arrayOfIndexes?.current?.[counter.current],
          animated: true
        });
      } catch (error) {
        counter.current = 0;
        flatList.current?.scrollToIndex({
          index: arrayOfIndexes?.current?.[counter.current],
          animated: true
        });
      }
    }
  }));
  (0, _react.useEffect)(() => {
    setArrayOfLines(text.split(/\r?\n/));
  }, [text]);
  (0, _react.useEffect)(() => {
    arrayOfIndexes.current = [];
    for (let index = 0; index < arrayOfLines.length; index++) {
      if (arrayOfLines[index]?.includes(textToHighlight)) {
        arrayOfIndexes.current = [...arrayOfIndexes.current, index];
      }
    }
  }, [arrayOfLines, textToHighlight]);
  return /*#__PURE__*/_react.default.createElement(_reactNativeGestureHandler.FlatList, {
    ref: flatList,
    initialScrollIndex: 0,
    data: arrayOfLines,
    initialNumToRender: 10000,
    renderItem: _ref2 => {
      let {
        item,
        index
      } = _ref2;
      return /*#__PURE__*/_react.default.createElement(_reactNativeHighlightText.default
      // eslint-disable-next-line react-native/no-inline-styles
      , {
        highlightStyle: {
          backgroundColor: 'yellow'
        },
        searchWords: [textToHighlight],
        textToHighlight: item
      });
    }
  });
}
var _default = /*#__PURE__*/(0, _react.forwardRef)(ScrollableHighlightedText); // interface HighlightTextProps extends FindAllArgs, TextProps {
//   highlightStyle?: TextStyle;
//   highlightComponent?: React.ComponentType<TextProps>;
//   textComponent?: React.ComponentType<TextProps>;
// }
exports.default = _default;
//# sourceMappingURL=index.js.map